﻿ ##### Scriptinfo ##################################################################################
# Scriptreihe:      Show TCPServer mit vielen Clients - Clientscript
# Datum:            2018-07-16
# Version:          V1.00
# Programmierer:    Stephan Walther
###################################################################################################
 
# Variablen
    $ServerName = 'localhost'
    $Port       = 9005

# erstelle TCP-Client    
    $SourcePort = Get-Random -Minimum 48086 -Maximum 53042
    $Endpoint   = New-Object System.Net.IPEndpoint ([ipaddress]::any,$SourcePort) 
    $TcpClient  = [Net.Sockets.TCPClient]$Endpoint

# warte auf Verbindung zum TCPServer            
    do{
        try   { $TcpClient.Connect("$ServerName",$Port) } 
        catch { Sleep 1 }
    } while (-not $TcpClient.Connected)
    $DataStream = $TcpClient.GetStream()

# solange kein 'close' gesendet wird: empfange Messages
    $Message = ""
    do {        
        if ($DataStream.DataAvailable) {
            $Message = ""  
            do {    
                [byte[]]$byte = New-Object byte[] 64512
                $byteCount = $DataStream.read($byte, 0, $byte.Length)
                $Message += [text.encoding]::ASCII.GetString( (1..$byteCount | ForEach-Object { $byte[$_-1] } ) )
            } while ($DataStream.DataAvailable)
                                  
            write-host "$Message"
        } else {            
            Start-Sleep -Milliseconds 100
        }
    } while ($Message -ne "close")

# beende TcpClient        
    $TcpClient.Close()
    $TcpClient.Dispose()